package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.domain.Specifications;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.entities.DetailKajianEvaluasi;
import com.jasamedika.medifirst2000.entities.KajianEvaluasi;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DetailKajianEvaluasiService;
import com.jasamedika.medifirst2000.service.KajianEvaluasiService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.DetailKajianEvaluasiVO;
import com.jasamedika.medifirst2000.vo.KajianEvaluasiVO;

import net.kaczmarzyk.spring.data.jpa.domain.DateBetween;
import net.kaczmarzyk.spring.data.jpa.domain.Equal;
import net.kaczmarzyk.spring.data.jpa.web.annotation.Spec;

@RestController
@RequestMapping("/kajian-evaluasi")
public class KajianEvaluasiController extends LocaleController<KajianEvaluasiVO>
 {

	@Autowired
	private KajianEvaluasiService evaluasiService;
	
	@Autowired
	private DetailKajianEvaluasiService detailService;
	
	private static final Logger LOGGER = LoggerFactory
			.getLogger(PegawaiController.class);
	
	@RequestMapping(value="/find-all/",method= RequestMethod.GET)
	public ResponseEntity<List<Object>> findAll(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "20") Integer take,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@Spec(path = "tglUsulan", params = {"dateStart", "dateEnd"}, config = "yyyy-MM-dd", spec = DateBetween.class) Specification<KajianEvaluasi> tglUsulan,
			@Spec(path = "noUsulan", params = "noUsulan" , spec = Equal.class) Specification<KajianEvaluasi> noUsulan,
			@Spec(path = "id", params = "id" , spec = Equal.class) Specification<KajianEvaluasi> id) {
			Map<String,Object> result = new HashMap<String, Object>();
			
			Specification<KajianEvaluasi> spec = Specifications.where(tglUsulan).and(noUsulan).and(id);
			result = evaluasiService.findAll(page, take, sort, dir, spec);
			return constructListPageResult(result);
	}

	@RequestMapping(value="/find-all-by-jabatan/",method= RequestMethod.GET)
	public ResponseEntity<List<Object>> findAllByJabatan(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "20") Integer take,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@Spec(path = "kajianEvaluasi.tglUsulan", params = {"dateStart", "dateEnd"}, config = "yyyy-MM-dd", spec = DateBetween.class) Specification<DetailKajianEvaluasi> tglUsulan,
			@Spec(path = "kajianEvaluasi.noUsulan", params = "noUsulan" , spec = Equal.class) Specification<DetailKajianEvaluasi> noUsulan,
			@Spec(path = "tujuan.id",params="jabatanId",spec=Equal.class)Specification<DetailKajianEvaluasi> tujuanId,
			@Spec(path = "id", params = "id" , spec = Equal.class) Specification<DetailKajianEvaluasi> id) {
			Map<String,Object> result = new HashMap<String, Object>();
			
			Specification<DetailKajianEvaluasi> spec = Specifications.where(tglUsulan).and(tujuanId).and(noUsulan).and(id);
			result = detailService.findAll(page, take, sort, dir, spec);
			return constructListPageResult(result);
	}
	@RequestMapping(value="/save/",method= RequestMethod.POST)
	public ResponseEntity<Map<String,Object>> saveKajian(@Valid @RequestBody KajianEvaluasiVO vo,HttpServletRequest request){
		try{
			Map<String, Object> result = evaluasiService.saveKajian(vo);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add kajian", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add kajian", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	@RequestMapping(value="/update-kajian/",method= RequestMethod.POST)
	public ResponseEntity<Map<String,Object>> updateKajian(@Valid @RequestBody List<DetailKajianEvaluasiVO> vos,HttpServletRequest request){
		try{
			Map<String, Object> result = detailService.updateKajian(vos);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when update kajian", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when update kajian", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	
	@RequestMapping(value="/delete/",method= RequestMethod.POST)
	public ResponseEntity<Map<String,Object>> deleteKajian(@Valid @RequestBody List<KajianEvaluasiVO> vos,HttpServletRequest request){
		try{
			Map<String, Object> result = evaluasiService.deleteKajian(vos);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when delete kajian", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when delete kajian", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	@RequestMapping(value="/generate-no-usulan/{bulan}/{tahun}",method= RequestMethod.GET)
	public ResponseEntity<Map<String,Object>> getGenerateNoUsulan(
			@PathVariable("bulan") Integer bulan,
			@PathVariable("tahun") Integer tahun,
			HttpServletRequest request)
	{
		try{
			Map<String,Object> result = evaluasiService.generateNoUsulan(bulan, tahun);
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
		}catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when generate no usulan", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when generate no usulan", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}
	
	 
	
	
}
